<!DOCTYPE html>
<!--
目標：讓 mario 可以左右移動，並在接觸到 star 的時候，讓 star 消失，
且分數 +1
-->
<html lang="en">
  <head>
    <title>Hello!</title>
    <meta charset="utf-8" />
    <meta http-equiv="X-UA-Compatible" content="IE=edge" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
  </head>
  <body>
    <span id="score"></span><br/>
    <img style="display: none" id="mario" src="https://cdn.glitch.me/372373dd-bb74-4b00-b938-bbf796cf8ebf/pngaaa.com-1198218.png?v=1640742982064"/>
    <img style="display: none" id="star" src="https://cdn.glitch.me/372373dd-bb74-4b00-b938-bbf796cf8ebf/star.png?v=1640743662784"/>
    <canvas id="c" width="500" height="500"></canvas>
    <script>
      let score=0;
      let canvas = document.getElementById("c");
      let mario=document.getElementById("mario");
      let star=document.getElementById("star");
      let ctx = canvas.getContext("2d");

      let components = [];
      let round = 0;
      function loop() {
        document.getElementById("score").innerHTML=""+score;
        ctx.save();
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        
        for (let component of components) {
          if (component.getType() == "Obstacle") {
            if (round++ % 3 == 0 && Math.random() < 0.4) {
              component.y = component.y + 5;
              if (Math.random() < 0.2) {
                component.x = component.x + 1;
              } else if (Math.random() > 0.8) {
                component.x = component.x - 1;
              }
            }
          }
          component.update();
        }
        //now, we check overlap between all pairs of components
        outer: for(let i=0; i<components.length; i++){
          for(let j=i+1; j<components.length; j++){
            if(!components[i].visible || !components[j].visible){
              //then skip
              continue;
            }
            if(isOverlap(components[i], components[j])){
              //hint: 檢查碰撞的雙方，進行條件及分數的判定
              if(components[i].getType()=="MainComponent" && components[j].getType() == "Obstacle"){
                components[j].visible = false;
                score+=1;
                if(score == 50){
                  alert("You win!!");
                  break outer;
                }
              
              }
          }
          
          }
        }
        let oldComponents=components;
        components=[];
        //check game state & collect new sets of components to save memory
        for(let component of oldComponents){
          if(!component.visible){
            continue;
          }
          
          if(component.y>=0 && component.y<=canvas.height){
            components.push(component);
          }
        }
        
        ctx.restore();
        if (true) {
          setTimeout(function() {
            window.requestAnimationFrame(loop);
          }, 1000 / 25);
        }
      }
      window.requestAnimationFrame(loop);

      class Component {
        constructor(x, y, width, height) {
          this.x = x;
          this.y = y;
          this.width = width;
          this.height = height;
          this.visible = true;
        }
        getType() {
          return "unknown";
        }
        update() {}
      }

      class MainComponent extends Component {
        constructor(x, y) {
          super(x, y, 100, 150);
        }
        getType() {
          return "MainComponent";
        }
        update() {
          if (this.visible) {
            ctx.drawImage(mario, 0, 0, 200, 307, this.x, this.y, 50, 80);
          }
        }
      }

      class Obstacle extends Component {
        constructor(x, y) {
          super(x, y, 30, 30);
        }
        getType() {
          return "Obstacle";
        }
        update() {
          if (this.visible) {
            ctx.drawImage(star, 0, 0, 30, 30, this.x, this.y, 30, 30);
          }
        }
      }

      function isOverlap(obj1, obj2) {
        let overlap = !(
          obj1.x + obj1.width < obj2.x ||
          obj1.x > obj2.x + obj2.width ||
          obj1.y + obj1.height < obj2.y ||
          obj1.y > obj2.y + obj2.height
        );
        return overlap;
      }

      let mainComponent = new MainComponent(
        canvas.width / 2,
        canvas.height/2
      );
      components.push(mainComponent);
      for (let y = 0; y < 10; y++) {
        for (let x = 0; x < 5; x++) {
          let ob1 = new Obstacle(
            Math.floor(Math.random() * canvas.width),
            (y + 1) * 5
          );
          components.push(ob1);
        }
      }

      function onKeyDown(e) {
        //hint: 讓 mario 可以左右移動
        if(e.keyCode==37){
          mainComponent.x = mainComponent.x-3;
        }
        if(e.keyCode==39){
          mainComponent.x = mainComponent.x+3;
        }
        if(mainComponent.x>=500){
          mainComponent.x= -50;
        }
        if(mainComponent.x<-50){
          mainComponent.x = 500;
        }
      }
      window.addEventListener("keydown", onKeyDown);
    </script>
  </body>
</html>
